/*
   scalarprod_g - caluclate and time the scalar product
   
   Linux version
   
   EEE4084F prepated by S. Winberg 2017
*/

#include <iostream>
#include <ctime>
#include <sys/time.h>
#include <stdlib.h> // for srand, rand

timeval clk_tic, clk_toc;

void CPU_tic () {
 gettimeofday(&clk_tic, NULL);
}


double CPU_toc () {
 gettimeofday(&clk_toc, NULL);
 double t = double(clk_toc.tv_sec -clk_tic.tv_sec )
          + double(clk_toc.tv_usec-clk_tic.tv_usec) * 1.e-6;
          
 return t;
}

double CPU_ticks_to_ms (long ticks)
{
	return ticks * 1000.0;
}

float random_f ()
{
	return (float)rand()/(float)(RAND_MAX);
}

float scalarprod (float* a, float* b, int n) {
	unsigned i;
	// get initial tick value
	CPU_tic(); 
	// Do processing ...
	// provide random seed
    srand((unsigned int)time(NULL));
    // first initialize the vectors
    for (i=0; i<n; i++) {
          a[i] = random_f(); 
          b[i] = random_f(); 
      }
	float sum = 0.0f;
    for (i=0; i<n; i++) {
         sum = sum + (a[i] * b[i]);
       }
    // get the time elapsed
    double t1 = CPU_toc();  // get final tick value
    std::cout << "scalarprod n=" << n << " took " << t1 << " ms\n";
}


int main(int argc, char** argv) {
	#define N 100240
	float x[N], y[N];
	float z = scalarprod(x,y,N);
	std::cout << "x * y = " << z << std::endl;
	return 0;
}

