/*
   scalarprod_g - caluclate and time the scalar product
   
   Windows version
   
   EEE4084F prepated by S. Winberg 2017
*/

#include <iostream>
#include <windows.h>
#include <ctime>

LARGE_INTEGER clk_frequency, clk_tic;

void CPU_tic ()
{
	QueryPerformanceFrequency(&clk_frequency);
	QueryPerformanceCounter(&clk_tic);
}

double CPU_toc () {
   LARGE_INTEGER clk_toc;
   QueryPerformanceCounter(&clk_toc);
   return (double)(clk_toc.QuadPart - clk_tic.QuadPart) * 1000.0 / clk_frequency.QuadPart;
}


double CPU_ticks_to_ms (long ticks)
{
	return (double)ticks / CLOCKS_PER_SEC * 1000.0;
}

float random_f ()
{
	return (float)rand()/(float)(RAND_MAX);
}

float scalarprod (float* a, float* b, int n) {
	unsigned i;
	// get initial tick value
	CPU_tic(); 
	// Do processing ...
	// provide random seed
    srand((unsigned int)time(NULL));
    // first initialize the vectors
    for (i=0; i<n; i++) {
          a[i] = random_f(); 
          b[i] = random_f(); 
      }
	float sum = 0.0f;
    for (i=0; i<n; i++) {
         sum = sum + (a[i] * b[i]);
       }
    // get the time elapsed
    double t1 = CPU_toc();  // get final tick value
    std::cout << "scalarprod n=" << n << " took " << t1 << " ms\n";
}


int main(int argc, char** argv) {
	#define N 1024
	float x[N], y[N];
	float z = scalarprod(x,y,N);
	std::cout << "x * y = " << z << std::endl;
	return 0;
}

